<?php
namespace MK\Test\Controller;

/***
 *
 * This file is part of the "test" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2018
 *
 ***/

/**
 * RootObjectController
 */
class RootObjectController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{
    /**
     * rootObjectRepository
     *
     * @var \MK\Test\Domain\Repository\RootObjectRepository
     * @inject
     */
    protected $rootObjectRepository = null;

    /**
     * action list
     *
     * @return void
     */
    public function listAction()
    {
        $rootObjects = $this->rootObjectRepository->findAll();
        $this->view->assign('rootObjects', $rootObjects);
    }

    /**
     * action show
     *
     * @param \MK\Test\Domain\Model\RootObject $rootObject
     * @return void
     */
    public function showAction(\MK\Test\Domain\Model\RootObject $rootObject)
    {
        $this->view->assign('rootObject', $rootObject);
    }

    /**
     * action new
     *
     * @return void
     */
    public function newAction()
    {

    }

    /**
     * action create
     *
     * @param \MK\Test\Domain\Model\RootObject $newRootObject
     * @return void
     */
    public function createAction(\MK\Test\Domain\Model\RootObject $newRootObject)
    {
        $this->addFlashMessage('The object was created. Please be aware that this action is publicly accessible unless you implement an access check. See https://docs.typo3.org/typo3cms/extensions/extension_builder/User/Index.html', '', \TYPO3\CMS\Core\Messaging\AbstractMessage::WARNING);
        $this->rootObjectRepository->add($newRootObject);
        $this->redirect('list');
    }

    /**
     * action edit
     *
     * @param \MK\Test\Domain\Model\RootObject $rootObject
     * @ignorevalidation $rootObject
     * @return void
     */
    public function editAction(\MK\Test\Domain\Model\RootObject $rootObject)
    {
        $this->view->assign('rootObject', $rootObject);
    }

    /**
     * action update
     *
     * @param \MK\Test\Domain\Model\RootObject $rootObject
     * @return void
     */
    public function updateAction(\MK\Test\Domain\Model\RootObject $rootObject)
    {
        $this->addFlashMessage('The object was updated. Please be aware that this action is publicly accessible unless you implement an access check. See https://docs.typo3.org/typo3cms/extensions/extension_builder/User/Index.html', '', \TYPO3\CMS\Core\Messaging\AbstractMessage::WARNING);
        $this->rootObjectRepository->update($rootObject);
        $this->redirect('list');
    }
}
